# $Id: /mirror/youri/soft/submit/trunk/lib/Youri/Submit/Test/Precedence.pm 1381 2006-12-02T10:47:18.983788Z guillomovitch  $
package Youri::Submit::Test::Precedence;

=head1 NAME

Youri::Submit::Test::Precedence - Release test against another test

=head1 DESCRIPTION

This test plugin rejects packages whose an older revision already exists for
another upload target.

=cut

use warnings;
use strict;
use Carp;
use base qw/Youri::Submit::Test/;

sub _init {
    my $self   = shift;
    my %options = (
        _target => undef, # mandatory targets
        @_
    );

    croak "undefined target" unless $options{target};

    $self->{_target} = $options{target};
}

sub process_package {
    my ($self, $package, $repository, $target, $define) = @_;
    croak "Not a class method" unless ref $self;

    my @errors;

    my @older_revisions = 
        $repository->get_older_revisions($package, $self->{_target}, $define);
    if (@older_revisions) {
        push(
            @errors,
            "Older revisions still exists for $self->{_target}: " . join(', ', @older_revisions)
        );
    }

    return @errors;
}

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2002-2006, YOURI project

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

=cut

1;
