# $Id: /mirror/youri/soft/submit/trunk/lib/Youri/Submit/Test/Type.pm 1381 2006-12-02T10:47:18.983788Z guillomovitch  $
package Youri::Submit::Test::Type;

=head1 NAME

Youri::Submit::Test::Type - Type test

=head1 DESCRIPTION

This test plugin rejects packages with incorrect type.

=cut

use warnings;
use strict;
use Carp;
use base qw/Youri::Submit::Test/;

sub _init {
    my $self   = shift;
    my %options = (
        type => undef, # expected type
        @_
    );

    croak "no type to test" unless $options{type};
    croak "invalid type value" unless $options{type} =~ /^(?:source|binary)$/;

    $self->{_type} = $options{type};
}

sub process_package {
    my ($self, $package, $repository, $target, $define) = @_;
    croak "Not a class method" unless ref $self;

    my @errors;

    my $type = $package->get_type();
    if ($type ne $self->{_type}) {
        push(@errors, "invalid type $type");
    }

    return @errors;
}

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2002-2006, YOURI project

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

=cut

1;
